package anywheresoftware.b4a.samples.camera;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = false;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "anywheresoftware.b4a.samples.camera", "anywheresoftware.b4a.samples.camera.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "anywheresoftware.b4a.samples.camera", "anywheresoftware.b4a.samples.camera.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "anywheresoftware.b4a.samples.camera.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
//        try {
//            if (processBA.subExists("activity_actionbarhomeclick")) {
//                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
//                    getClass().getMethod("getActionBar").invoke(this), true);
//                BA.Log("adding event");
//            }
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
		return true;
	}   
// @Override
// public boolean onOptionsItemSelected(android.view.MenuItem item) {
//    if (item.getItemId() == 16908332) {
//        processBA.raiseEvent(null, "activity_actionbarhomeclick");
//        return true;
//    }
//    else
//        return super.onOptionsItemSelected(item); 
//}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static boolean _frontcamera = false;
public anywheresoftware.b4a.objects.PanelWrapper _panel1 = null;
public anywheresoftware.b4a.samples.camera.cameraexclass _camex = null;
public anywheresoftware.b4a.objects.ImageViewWrapper _imageview1 = null;
public anywheresoftware.b4a.agraham.jpegutils.ExifUtils _exif = null;
public static String _target = "";
public static String _fp = "";
  public Object[] GetGlobals() {
		return new Object[] {"Activity",mostCurrent._activity,"camEx",mostCurrent._camex,"exif",mostCurrent._exif,"fp",mostCurrent._fp,"frontCamera",_frontcamera,"ImageView1",mostCurrent._imageview1,"Panel1",mostCurrent._panel1,"target",mostCurrent._target};
}

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}

public static void killProgram() {
     {
            Activity __a = null;
            if (main.previousOne != null) {
				__a = main.previousOne.get();
			}
            else {
                BA ba = main.mostCurrent.processBA.sharedProcessBA.activityBA.get();
                if (ba != null) __a = ba.activity;
            }
            if (__a != null)
				__a.finish();}

}
public static String  _activity_create(boolean _firsttime) throws Exception{
try {
		Debug.PushSubsStack("Activity_Create (main) ","main",0,mostCurrent.activityBA,mostCurrent,24);
Debug.locals.put("FirstTime", _firsttime);
 BA.debugLineNum = 24;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
Debug.ShouldStop(8388608);
 BA.debugLineNum = 25;BA.debugLine="Activity.LoadLayout(\"1\")";
Debug.ShouldStop(16777216);
mostCurrent._activity.LoadLayout("1",mostCurrent.activityBA);
 BA.debugLineNum = 27;BA.debugLine="If File.ExternalWritable Then target = File.DirDefaultExternal Else target = File.DirInternal";
Debug.ShouldStop(67108864);
if (anywheresoftware.b4a.keywords.Common.File.getExternalWritable()) { 
mostCurrent._target = anywheresoftware.b4a.keywords.Common.File.getDirDefaultExternal();}
else {
mostCurrent._target = anywheresoftware.b4a.keywords.Common.File.getDirInternal();};
 BA.debugLineNum = 28;BA.debugLine="File.MakeDir(target, \"testcamera\")";
Debug.ShouldStop(134217728);
anywheresoftware.b4a.keywords.Common.File.MakeDir(mostCurrent._target,"testcamera");
 BA.debugLineNum = 29;BA.debugLine="fp = File.Combine(target,\"testcamera\")";
Debug.ShouldStop(268435456);
mostCurrent._fp = anywheresoftware.b4a.keywords.Common.File.Combine(mostCurrent._target,"testcamera");
 BA.debugLineNum = 31;BA.debugLine="End Sub";
Debug.ShouldStop(1073741824);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_pause(boolean _userclosed) throws Exception{
try {
		Debug.PushSubsStack("Activity_Pause (main) ","main",0,mostCurrent.activityBA,mostCurrent,42);
Debug.locals.put("UserClosed", _userclosed);
 BA.debugLineNum = 42;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
Debug.ShouldStop(512);
 BA.debugLineNum = 43;BA.debugLine="camEx.Release";
Debug.ShouldStop(1024);
mostCurrent._camex._release();
 BA.debugLineNum = 44;BA.debugLine="End Sub";
Debug.ShouldStop(2048);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_resume() throws Exception{
try {
		Debug.PushSubsStack("Activity_Resume (main) ","main",0,mostCurrent.activityBA,mostCurrent,33);
 BA.debugLineNum = 33;BA.debugLine="Sub Activity_Resume";
Debug.ShouldStop(1);
 BA.debugLineNum = 34;BA.debugLine="InitializeCamera";
Debug.ShouldStop(2);
_initializecamera();
 BA.debugLineNum = 35;BA.debugLine="End Sub";
Debug.ShouldStop(4);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _btneffect_click() throws Exception{
try {
		Debug.PushSubsStack("btnEffect_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent,96);
anywheresoftware.b4a.objects.collections.List _effects = null;
String _effect = "";
 BA.debugLineNum = 96;BA.debugLine="Sub btnEffect_Click";
Debug.ShouldStop(-2147483648);
 BA.debugLineNum = 97;BA.debugLine="Dim effects As List = camEx.GetSupportedColorEffects";
Debug.ShouldStop(1);
_effects = new anywheresoftware.b4a.objects.collections.List();
_effects = mostCurrent._camex._getsupportedcoloreffects();Debug.locals.put("effects", _effects);Debug.locals.put("effects", _effects);
 BA.debugLineNum = 98;BA.debugLine="If effects.IsInitialized = False Then";
Debug.ShouldStop(2);
if (_effects.IsInitialized()==anywheresoftware.b4a.keywords.Common.False) { 
 BA.debugLineNum = 99;BA.debugLine="ToastMessageShow(\"Effects not supported.\", False)";
Debug.ShouldStop(4);
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Effects not supported.",anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 100;BA.debugLine="Return";
Debug.ShouldStop(8);
if (true) return "";
 };
 BA.debugLineNum = 102;BA.debugLine="Dim effect As String = effects.Get((effects.IndexOf(camEx.GetColorEffect) + 1) Mod effects.Size)";
Debug.ShouldStop(32);
_effect = BA.ObjectToString(_effects.Get((int) ((_effects.IndexOf((Object)(mostCurrent._camex._getcoloreffect()))+1)%_effects.getSize())));Debug.locals.put("effect", _effect);Debug.locals.put("effect", _effect);
 BA.debugLineNum = 103;BA.debugLine="camEx.SetColorEffect(effect)";
Debug.ShouldStop(64);
mostCurrent._camex._setcoloreffect(_effect);
 BA.debugLineNum = 104;BA.debugLine="ToastMessageShow(effect, False)";
Debug.ShouldStop(128);
anywheresoftware.b4a.keywords.Common.ToastMessageShow(_effect,anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 105;BA.debugLine="camEx.CommitParameters";
Debug.ShouldStop(256);
mostCurrent._camex._commitparameters();
 BA.debugLineNum = 106;BA.debugLine="End Sub";
Debug.ShouldStop(512);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _btnflash_click() throws Exception{
try {
		Debug.PushSubsStack("btnFlash_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent,108);
float[] _f = null;
anywheresoftware.b4a.objects.collections.List _flashmodes = null;
String _flash = "";
 BA.debugLineNum = 108;BA.debugLine="Sub btnFlash_Click";
Debug.ShouldStop(2048);
 BA.debugLineNum = 109;BA.debugLine="Dim f() As Float = camEx.GetFocusDistances";
Debug.ShouldStop(4096);
_f = mostCurrent._camex._getfocusdistances();Debug.locals.put("f", _f);Debug.locals.put("f", _f);
 BA.debugLineNum = 110;BA.debugLine="Log(f(0) & \", \" & f(1) & \", \" & f(2))";
Debug.ShouldStop(8192);
anywheresoftware.b4a.keywords.Common.Log(BA.NumberToString(_f[(int) (0)])+", "+BA.NumberToString(_f[(int) (1)])+", "+BA.NumberToString(_f[(int) (2)]));
 BA.debugLineNum = 111;BA.debugLine="Dim flashModes As List = camEx.GetSupportedFlashModes";
Debug.ShouldStop(16384);
_flashmodes = new anywheresoftware.b4a.objects.collections.List();
_flashmodes = mostCurrent._camex._getsupportedflashmodes();Debug.locals.put("flashModes", _flashmodes);Debug.locals.put("flashModes", _flashmodes);
 BA.debugLineNum = 112;BA.debugLine="If flashModes.IsInitialized = False Then";
Debug.ShouldStop(32768);
if (_flashmodes.IsInitialized()==anywheresoftware.b4a.keywords.Common.False) { 
 BA.debugLineNum = 113;BA.debugLine="ToastMessageShow(\"Flash not supported.\", False)";
Debug.ShouldStop(65536);
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Flash not supported.",anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 114;BA.debugLine="Return";
Debug.ShouldStop(131072);
if (true) return "";
 };
 BA.debugLineNum = 116;BA.debugLine="Dim flash As String = flashModes.Get((flashModes.IndexOf(camEx.GetFlashMode) + 1) Mod flashModes.Size)";
Debug.ShouldStop(524288);
_flash = BA.ObjectToString(_flashmodes.Get((int) ((_flashmodes.IndexOf((Object)(mostCurrent._camex._getflashmode()))+1)%_flashmodes.getSize())));Debug.locals.put("flash", _flash);Debug.locals.put("flash", _flash);
 BA.debugLineNum = 117;BA.debugLine="camEx.SetFlashMode(flash)";
Debug.ShouldStop(1048576);
mostCurrent._camex._setflashmode(_flash);
 BA.debugLineNum = 118;BA.debugLine="ToastMessageShow(flash, False)";
Debug.ShouldStop(2097152);
anywheresoftware.b4a.keywords.Common.ToastMessageShow(_flash,anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 119;BA.debugLine="camEx.CommitParameters";
Debug.ShouldStop(4194304);
mostCurrent._camex._commitparameters();
 BA.debugLineNum = 120;BA.debugLine="End Sub";
Debug.ShouldStop(8388608);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _btnfocus_click() throws Exception{
try {
		Debug.PushSubsStack("btnFocus_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent,61);
 BA.debugLineNum = 61;BA.debugLine="Sub btnFocus_Click";
Debug.ShouldStop(268435456);
 BA.debugLineNum = 62;BA.debugLine="camEx.FocusAndTakePicture";
Debug.ShouldStop(536870912);
mostCurrent._camex._focusandtakepicture();
 BA.debugLineNum = 63;BA.debugLine="End Sub";
Debug.ShouldStop(1073741824);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _btnpicturesize_click() throws Exception{
try {
		Debug.PushSubsStack("btnPictureSize_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent,121);
anywheresoftware.b4a.samples.camera.cameraexclass._camerasize[] _picturesizes = null;
anywheresoftware.b4a.samples.camera.cameraexclass._camerasize _current = null;
int _i = 0;
anywheresoftware.b4a.samples.camera.cameraexclass._camerasize _ps = null;
 BA.debugLineNum = 121;BA.debugLine="Sub btnPictureSize_Click";
Debug.ShouldStop(16777216);
 BA.debugLineNum = 122;BA.debugLine="Dim pictureSizes() As CameraSize = camEx.GetSupportedPicturesSizes";
Debug.ShouldStop(33554432);
_picturesizes = mostCurrent._camex._getsupportedpicturessizes();Debug.locals.put("pictureSizes", _picturesizes);Debug.locals.put("pictureSizes", _picturesizes);
 BA.debugLineNum = 123;BA.debugLine="Dim current As CameraSize = camEx.GetPictureSize";
Debug.ShouldStop(67108864);
_current = mostCurrent._camex._getpicturesize();Debug.locals.put("current", _current);Debug.locals.put("current", _current);
 BA.debugLineNum = 124;BA.debugLine="For i = 0 To pictureSizes.Length - 1";
Debug.ShouldStop(134217728);
{
final int step87 = 1;
final int limit87 = (int) (_picturesizes.length-1);
for (_i = (int) (0); (step87 > 0 && _i <= limit87) || (step87 < 0 && _i >= limit87); _i = ((int)(0 + _i + step87))) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 125;BA.debugLine="If pictureSizes(i).Width = current.Width AND pictureSizes(i).Height = current.Height Then Exit";
Debug.ShouldStop(268435456);
if (_picturesizes[_i].Width==_current.Width && _picturesizes[_i].Height==_current.Height) { 
if (true) break;};
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 127;BA.debugLine="Dim ps As CameraSize = pictureSizes((i + 1) Mod pictureSizes.Length)";
Debug.ShouldStop(1073741824);
_ps = _picturesizes[(int) ((_i+1)%_picturesizes.length)];Debug.locals.put("ps", _ps);Debug.locals.put("ps", _ps);
 BA.debugLineNum = 128;BA.debugLine="camEx.SetPictureSize(ps.Width, ps.Height)";
Debug.ShouldStop(-2147483648);
mostCurrent._camex._setpicturesize(_ps.Width,_ps.Height);
 BA.debugLineNum = 129;BA.debugLine="ToastMessageShow(ps.Width & \"x\" & ps.Height, False)";
Debug.ShouldStop(1);
anywheresoftware.b4a.keywords.Common.ToastMessageShow(BA.NumberToString(_ps.Width)+"x"+BA.NumberToString(_ps.Height),anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 130;BA.debugLine="camEx.CommitParameters";
Debug.ShouldStop(2);
mostCurrent._camex._commitparameters();
 BA.debugLineNum = 131;BA.debugLine="End Sub";
Debug.ShouldStop(4);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _btntakepicture_click() throws Exception{
try {
		Debug.PushSubsStack("btnTakePicture_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent,57);
 BA.debugLineNum = 57;BA.debugLine="Sub btnTakePicture_Click";
Debug.ShouldStop(16777216);
 BA.debugLineNum = 58;BA.debugLine="camEx.TakePicture";
Debug.ShouldStop(33554432);
mostCurrent._camex._takepicture();
 BA.debugLineNum = 59;BA.debugLine="End Sub";
Debug.ShouldStop(67108864);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _camera1_picturetaken(byte[] _data) throws Exception{
try {
		Debug.PushSubsStack("Camera1_PictureTaken (main) ","main",0,mostCurrent.activityBA,mostCurrent,65);
String _filename = "";
String _dir = "";
anywheresoftware.b4a.phone.Phone _phone = null;
anywheresoftware.b4a.objects.IntentWrapper _i = null;
Debug.locals.put("Data", _data);
 BA.debugLineNum = 65;BA.debugLine="Sub Camera1_PictureTaken (Data() As Byte)";
Debug.ShouldStop(1);
 BA.debugLineNum = 66;BA.debugLine="Dim filename As String = \"1.jpg\"";
Debug.ShouldStop(2);
_filename = "1.jpg";Debug.locals.put("filename", _filename);Debug.locals.put("filename", _filename);
 BA.debugLineNum = 67;BA.debugLine="Dim dir As String = fp";
Debug.ShouldStop(4);
_dir = mostCurrent._fp;Debug.locals.put("dir", _dir);Debug.locals.put("dir", _dir);
 BA.debugLineNum = 69;BA.debugLine="camEx.SavePictureToFile(Data, dir, filename)";
Debug.ShouldStop(16);
mostCurrent._camex._savepicturetofile(_data,_dir,_filename);
 BA.debugLineNum = 70;BA.debugLine="camEx.StartPreview 'restart preview";
Debug.ShouldStop(32);
mostCurrent._camex._startpreview();
 BA.debugLineNum = 73;BA.debugLine="Dim Phone As Phone";
Debug.ShouldStop(256);
_phone = new anywheresoftware.b4a.phone.Phone();Debug.locals.put("Phone", _phone);
 BA.debugLineNum = 74;BA.debugLine="Dim i As Intent";
Debug.ShouldStop(512);
_i = new anywheresoftware.b4a.objects.IntentWrapper();Debug.locals.put("i", _i);
 BA.debugLineNum = 75;BA.debugLine="i.Initialize(\"android.intent.action.MEDIA_SCANNER_SCAN_FILE\", _ 		\"file://\" & File.Combine(dir, filename))";
Debug.ShouldStop(1024);
_i.Initialize("android.intent.action.MEDIA_SCANNER_SCAN_FILE","file://"+anywheresoftware.b4a.keywords.Common.File.Combine(_dir,_filename));
 BA.debugLineNum = 77;BA.debugLine="Phone.SendBroadcastIntent(i)";
Debug.ShouldStop(4096);
_phone.SendBroadcastIntent((android.content.Intent)(_i.getObject()));
 BA.debugLineNum = 79;BA.debugLine="ImageView1.Bitmap = LoadBitmapSample(fp,\"1.jpg\",ImageView1.Width,ImageView1.Height)";
Debug.ShouldStop(16384);
mostCurrent._imageview1.setBitmap((android.graphics.Bitmap)(anywheresoftware.b4a.keywords.Common.LoadBitmapSample(mostCurrent._fp,"1.jpg",mostCurrent._imageview1.getWidth(),mostCurrent._imageview1.getHeight()).getObject()));
 BA.debugLineNum = 82;BA.debugLine="exif.Initialize(fp, \"tiradacamera.jpg\")";
Debug.ShouldStop(131072);
mostCurrent._exif.Initialize(mostCurrent._fp,"tiradacamera.jpg");
 BA.debugLineNum = 84;BA.debugLine="Msgbox(\"the current photo orientation is = \" & exif.getAttribute(exif.TAG_ORIENTATION) & \"... on the galaxy s3 is 6 here EVER!\",\"Camera Test\")";
Debug.ShouldStop(524288);
anywheresoftware.b4a.keywords.Common.Msgbox("the current photo orientation is = "+mostCurrent._exif.getAttribute(mostCurrent._exif.TAG_ORIENTATION)+"... on the galaxy s3 is 6 here EVER!","Camera Test",mostCurrent.activityBA);
 BA.debugLineNum = 88;BA.debugLine="End Sub";
Debug.ShouldStop(8388608);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _camera1_ready(boolean _success) throws Exception{
try {
		Debug.PushSubsStack("Camera1_Ready (main) ","main",0,mostCurrent.activityBA,mostCurrent,46);
Debug.locals.put("Success", _success);
 BA.debugLineNum = 46;BA.debugLine="Sub Camera1_Ready (Success As Boolean)";
Debug.ShouldStop(8192);
 BA.debugLineNum = 47;BA.debugLine="If Success Then";
Debug.ShouldStop(16384);
if (_success) { 
 BA.debugLineNum = 48;BA.debugLine="camEx.SetJpegQuality(90)";
Debug.ShouldStop(32768);
mostCurrent._camex._setjpegquality((int) (90));
 BA.debugLineNum = 49;BA.debugLine="camEx.CommitParameters";
Debug.ShouldStop(65536);
mostCurrent._camex._commitparameters();
 BA.debugLineNum = 50;BA.debugLine="camEx.StartPreview";
Debug.ShouldStop(131072);
mostCurrent._camex._startpreview();
 BA.debugLineNum = 51;BA.debugLine="Log(camEx.GetPreviewSize)";
Debug.ShouldStop(262144);
anywheresoftware.b4a.keywords.Common.Log(BA.ObjectToString(mostCurrent._camex._getpreviewsize()));
 }else {
 BA.debugLineNum = 53;BA.debugLine="ToastMessageShow(\"Cannot open camera.\", True)";
Debug.ShouldStop(1048576);
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Cannot open camera.",anywheresoftware.b4a.keywords.Common.True);
 };
 BA.debugLineNum = 55;BA.debugLine="End Sub";
Debug.ShouldStop(4194304);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _changecamera_click() throws Exception{
try {
		Debug.PushSubsStack("ChangeCamera_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent,90);
 BA.debugLineNum = 90;BA.debugLine="Sub ChangeCamera_Click";
Debug.ShouldStop(33554432);
 BA.debugLineNum = 91;BA.debugLine="camEx.Release";
Debug.ShouldStop(67108864);
mostCurrent._camex._release();
 BA.debugLineNum = 92;BA.debugLine="frontCamera = Not(frontCamera)";
Debug.ShouldStop(134217728);
_frontcamera = anywheresoftware.b4a.keywords.Common.Not(_frontcamera);
 BA.debugLineNum = 93;BA.debugLine="InitializeCamera";
Debug.ShouldStop(268435456);
_initializecamera();
 BA.debugLineNum = 94;BA.debugLine="End Sub";
Debug.ShouldStop(536870912);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}

public static void initializeProcessGlobals() {
    if (mostCurrent != null && mostCurrent.activityBA != null) {
Debug.StartDebugging(mostCurrent.activityBA, 23171, new int[] {5, 9}, "50913134-1528-4bd5-8ad9-b217e60a10d4");}

    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _globals() throws Exception{
 //BA.debugLineNum = 16;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 17;BA.debugLine="Private Panel1 As Panel";
mostCurrent._panel1 = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 18;BA.debugLine="Private camEx As CameraExClass";
mostCurrent._camex = new anywheresoftware.b4a.samples.camera.cameraexclass();
 //BA.debugLineNum = 19;BA.debugLine="Private ImageView1 As ImageView";
mostCurrent._imageview1 = new anywheresoftware.b4a.objects.ImageViewWrapper();
 //BA.debugLineNum = 20;BA.debugLine="Private exif As ExifData";
mostCurrent._exif = new anywheresoftware.b4a.agraham.jpegutils.ExifUtils();
 //BA.debugLineNum = 21;BA.debugLine="Private target, fp As String";
mostCurrent._target = "";
mostCurrent._fp = "";
 //BA.debugLineNum = 22;BA.debugLine="End Sub";
return "";
}
public static String  _initializecamera() throws Exception{
try {
		Debug.PushSubsStack("InitializeCamera (main) ","main",0,mostCurrent.activityBA,mostCurrent,37);
 BA.debugLineNum = 37;BA.debugLine="Private Sub InitializeCamera";
Debug.ShouldStop(16);
 BA.debugLineNum = 38;BA.debugLine="camEx.Initialize(Panel1, frontCamera, Me, \"Camera1\")";
Debug.ShouldStop(32);
mostCurrent._camex._initialize(mostCurrent.activityBA,mostCurrent._panel1,_frontcamera,main.getObject(),"Camera1");
 BA.debugLineNum = 39;BA.debugLine="frontCamera = camEx.Front";
Debug.ShouldStop(64);
_frontcamera = mostCurrent._camex._front;
 BA.debugLineNum = 40;BA.debugLine="End Sub";
Debug.ShouldStop(128);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 12;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 13;BA.debugLine="Private frontCamera As Boolean = False";
_frontcamera = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 14;BA.debugLine="End Sub";
return "";
}
}
